#include <stdio.h>
#include <map>
#include <string>
#include <stdlib.h>

#define DEBUG

using namespace std;

const int MAX_NAME = 10000;
const int MAX_J = 5;
const int MAX_P = 5;
const int MAX_W = 100002;

long long gcd(long long a, long long b)
{
	if ( b == 0 )  return a;
	else return gcd(b,a % b);
}

long long gcd(long long a, long long b, long long c)
{
	return gcd(a, gcd(b, c));
}

long long lcm(long long a, long long b)
{
	return (a * b) / gcd(a,b);
}

long long lcm(long long a, long long b, long long c)
{
	return (a * b * c) / gcd(a,b,c);
}


void Solve();
void calc_wp(int, long long);

int main()
{
	int T;

	scanf("%d", &T);
	for ( int t = 0; t < T; ++t )
	{
		Solve();
	}
}

int P;
long long p_lcm;
int J;
int W;
long long wlasciwy_przelicznik[MAX_J];
int przelicznik[MAX_J][MAX_J];

struct Patern
{
	int v;
	int j;
	int r;
};

Patern patern[MAX_W];

int f_cmp(const void *a, const void *b)
{
	return (*(Patern*)a).r - (*(Patern*)b).r;
}

void Solve()
{
	map<string, int> jednostka;
	int ppp[MAX_P];
	int J = 0;

	for ( int i = 0; i < MAX_J; ++i)
		for ( int j = 0; j < MAX_J; ++j )
			przelicznik[i][j] = 0;

	scanf("%d", &P);

	for ( int p = 0; p < P; ++p )
	{
		int przel;
		char tmp[10];
		char j1[MAX_NAME], j2[MAX_NAME];
		
		scanf("%s %s %s %d %s", tmp, j1, tmp, &przel, j2);

		printf("%s %d %s", j1, przel, j2);
		
		if ( jednostka.find(j1) == jednostka.end() )
			jednostka[j1] = J++;
		if ( jednostka.find(j2) == jednostka.end() )
			jednostka[j2] = J++;
		
		przelicznik[jednostka[j1]][jednostka[j2]] = przel;
		ppp[p] = przel;
	}

	if ( P == 2 )  p_lcm = lcm(ppp[0], ppp[1]);
	else if ( P == 3 )  p_lcm = lcm(ppp[0], ppp[1], ppp[2]);

	for ( int j = 0; j < J; ++j )
		calc_wp(j, (long long)1);

	scanf("%d", &W);
	for ( int w = 0; w < W; ++w )
	{
		char jedn[MAX_NAME];
		int v;
		scanf("%d %s", &v, &jedn);
		patern[w].v = v;
		patern[w].j = jednostka[jedn];		
		patern[w].r = v * wlasciwy_przelicznik[patern[w].j];
	}

	qsort(patern, W, sizeof(Patern), f_cmp);

#ifdef DEBUG
	printf("W: %d\n P: %d\n", W, P);
	for ( int w = 0; w < W; ++w )
	{
		printf("%d ", patern[w].r);
	}

	for ( int j = 0; j < J; ++j )
		printf("j: %d %d", j, wlasciwy_przelicznik[j]);
#endif
}


void calc_wp(int j, long long mult)
{
	for ( int i = 0; i < J; ++i )	
	{
		if ( i != j && przelicznik[i][j] > 0 )
		{
			calc_wp(j, mult * przelicznik[i][j]);
			return;
		}	
	}
	wlasciwy_przelicznik[j] = p_lcm / mult;
}	

